#include <stdio.h>
#include <string.h>
#include "mem.h"

/* return: 1: at least one macro has been expanded */
/*         0: no macro found */
static int _expand_str(char *tpl, char **str)
{
	char *new_s=NULL;
	char *s, *pl, *pr, *macro=NULL, *head=NULL, *tail=NULL;
	int rc=0;

	if (str==NULL || *str==NULL)
		return;

  s = *str;
	
	while (*s && cnt++ < too_deep)
	{
		if (NULL == (pl = strstr(s, tpl)))
			break;
		if (NULL == (pr = strstr(pl+strlen(tpl), tpl)))
			break;
		
		s[pl-s] = '\0';
		s[pr-s] = '\0';
		
		new_s = xstrcat (new_s, s);

		s = pl + strlen (tpl);
		
		macro = xstrcpy (s);

		if (!strcmp (tpl, "%"))
			rc = get_env_200 (&macro);

		if (rc == 0)
			rc = get_macro_200 (&macro);
		
		if (rc == 0)
			rc = get_macro_200 (&macro);
		if (rc == 0)
			rc = get_global_var_200 (&macro);

		new_s = xstrcat (new_s, macro);
		free (macro);
		
		s = pr + strlen (tpl);
	}
	
	new_s = xstrcat (new_s, s);

	
	free (*str);
	*str = xstrcpy (new_s);
	
	return rc;
}

void main (int argc, char **argv)
{
	char *s = argv[1];

	if (argc != 3)
		exit (1);

	_expand_str (argv[2], &s);

	printf ("\nreturned: `%s'\n", s);

}
